package cc.smtweb.framework.core;

import cc.smtweb.framework.core.cache.CacheManager;
import cc.smtweb.framework.core.db.impl.DatabaseUtil;
import cc.smtweb.framework.core.mvc.controller.scan.ApplicationScanner;
import cc.smtweb.framework.core.systask.TaskStartEvent;
import cc.smtweb.framework.core.systask.WebStartedEvent;
import lombok.SneakyThrows;
import org.springframework.boot.context.event.ApplicationStartedEvent;
import org.springframework.context.ApplicationListener;
import org.springframework.context.ConfigurableApplicationContext;
import org.springframework.stereotype.Component;

/**
 * 执行接口扫描任务
 */
@Component
public class CoreApplicationStartedListener implements ApplicationListener<ApplicationStartedEvent> {
  @SneakyThrows
  @Override
  public void onApplicationEvent(ApplicationStartedEvent event) {
    System.out.println("onApplicationEvent=============");
    ConfigurableApplicationContext applicationContext = event.getApplicationContext();

    applicationContext.publishEvent(new TaskStartEvent());
    //包扫描
    ApplicationScanner.scan(applicationContext);
    //初始化数据库
    new DatabaseUtil(true, false).checkDb();
    //初始化缓存
    CacheManager.getIntance().init();

    // 通知 controller 正式使用
    applicationContext.publishEvent(new WebStartedEvent());
    System.out.println("start end=============");
  }
}
