package cc.smtweb.framework.core.exception;

import cc.smtweb.framework.core.common.SwException;

import java.text.ParseException;

public class BindParamException extends SwException {
	/**
	 *
	 */
	private static final long serialVersionUID = 1L;
	private String paramName;

	public String getParamName() {
		return paramName;
	}

	public BindParamException(String message, String paramName) {
		this(message, null, paramName);
	}

	public BindParamException(Exception e, String paramName) {
		this(e.getMessage(), e, paramName);
	}

	public BindParamException(String message, Exception e, String paramName) {
		super("[" + paramName + "]" + message, e);
		this.paramName = paramName;
	}

	public BindParamException(ParseException e) {
		super(e);
	}
}
