package cc.smtweb.framework.web.web.api;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.annotation.*;
import cc.smtweb.framework.core.mvc.SchedulerManager;
import cc.smtweb.framework.core.mvc.scheduler.SchedulerPoint;
import cc.smtweb.framework.core.redis.RedisManager;
import cc.smtweb.framework.core.util.DateUtil;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@SwService
@SwPerm(SwPerm.NONE)
public class DemoTimerService {
  @SwParam
  private RedisManager redisManager;

  @SwParam
  private SchedulerManager schedulerManager;

  // defaultRun 命名的函数是默认函数
  public R defaultRun(@SwPathParam String path) {
    return R.success(path);
  }

  public R redis(@SwParam("time") int time) {
    boolean value = schedulerManager.wakeup(DemoTimerService.class, "timer3");

    return R.success(value);
  }

//  @SwScheduling(value = "*/10 * * * * ?", group = "web-timer")
  public void timer1(SchedulerPoint schedulerPoint) throws InterruptedException {
    String now = DateUtil.nowDateTime();
    System.out.printf("timer 1: %s start\n", now);

    Thread.sleep(30 * 1000);

    now = DateUtil.nowDateTime();
    System.out.printf("timer 1: %s end\n", now);

    schedulerPoint.put("id", now);
  }

//  @SwScheduling(value = "*/10 * * * * ?", group = "web-timer")
  public void timer2(SchedulerPoint schedulerPoint) {
    String now = DateUtil.nowDateTime();

    System.out.printf("timer 2: %s\n", now);

    schedulerPoint.put("time", now);
  }

//  @SwScheduling(value = "*/10 * * * * ?")
  public void timer3() {
    System.out.printf("timer 3: %s\n", DateUtil.nowDateTime());
  }
}
