package cc.smtweb.system.bpm.core.ui;

import cc.smtweb.framework.core.common.SwMap;
import lombok.Getter;

import java.util.ArrayList;
import java.util.List;

@Getter
public class BpmListData {
  public static final BpmListData EMPTY = new BpmListData(new ArrayList<>(), 0);

  private final List<SwMap> rows;
  // 总数, -1 表示需要异步获取数量， >=0 表示总数
  private int total;

  private BpmListData(List<SwMap> rows, int total) {
    this.rows = rows;
    this.total = total;
  }

  public static BpmListData create(List<SwMap> list, boolean loadCount) {
     if (list == null) {
       return BpmListData.EMPTY;
     }

     if (loadCount) {
       return new BpmListData(list, -1);
     } else {
       return new BpmListData(list, list.size());
     }
  }

  public boolean isEmpty() {
    return rows == null || rows.isEmpty();
  }
}
