package cc.smtweb.system.bpm.core.ui;

import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.mvc.controller.IBeanContext;
import cc.smtweb.framework.core.session.SessionUtil;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.framework.core.util.JsonUtil;
import cc.smtweb.system.bpm.core.ui.entity.dataset.BpmDataset;
import cc.smtweb.system.bpm.core.ui.entity.dataset.BpmFieldLookup;
import lombok.Getter;
import lombok.Setter;
import org.apache.commons.lang3.StringUtils;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

@Getter
public class BpmPageContext {
  static final String ATTR_MAP_BODY = "_bpm_map_body";
  private final IBeanContext context;
  private final Map<String, Object> params;
  private final HttpServletRequest request;
  private final String postBody;

  private SwMap body;
  private UserSession session;
  @Setter
  private boolean deploy = true;
  @Setter
  private String pageName;
  @Setter
  private BpmDataset dataset;
  @Setter
  private BpmFieldLookup fieldLookup;

//  BpmPageContext(SwMap body, UserSession session) {
//    this.body = body;
//    this.session = session;
//  }

  public BpmPageContext(IBeanContext context, Map<String, Object> params, String body, HttpServletRequest request) {
    this.context = context;
    this.params = params;
    this.request = request;
    this.postBody = body;

    SwMap mapBody = null;
    if (StringUtils.isNotBlank(body)) {
      mapBody = JsonUtil.parse(body, SwMap.class);
      request.setAttribute(ATTR_MAP_BODY, mapBody);
    }

    this.body = mapBody;
    this.session = (UserSession) SessionUtil.getSession();
  }

  public long getParamId() {
    return body.readLong(IParamConst.PARAM_ID, 0L);
  }
}
