package cc.smtweb.system.bpm.core.ui.bind;

import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.exception.BindBeanException;
import cc.smtweb.framework.core.mvc.controller.binder.attr.AbstractAttrEditor;
import cc.smtweb.system.bpm.util.BeanUtil;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * API函数@SwBody参数的转换处理，POST请求直接转换Json内容为Bean对象，GET请求转换Map请求参数为Bean对
 * @author xkliu
 */
public class BpmBeanAttrEditor extends AbstractAttrEditor implements IBpmBeanConst {
	@Override
	public Object getValue(String paramName, Class<?> paramType, HttpServletRequest request) {
		if (ATTRIBUTE_ROW.equals(paramName)) {
			return getBeanRow(paramType, request);
		} else if (ATTRIBUTE_ROWS.equals(paramName)) {
			return getBeanRows(paramType, request);
		}

		return request.getAttribute(paramName);
	}

	private Object getBeanRow(Class<?> paramType, HttpServletRequest request) {
		SwMap map = (SwMap)request.getAttribute(BEAN_ROW_MAP);
		Object bean = request.getAttribute(BEAN_ROW_BEAN);

		if (bean != null) {
			if (map != null) {
				// 逻辑有错误 map 和 bean 不会同时有值
				request.removeAttribute(BEAN_ROW_BEAN);
			}

//			if (paramType != null) {
//				if (!paramType.equals(bean.getClass())) {
//					throw new BindBeanException("type noe equals " + paramType.getName() + "," + bean.getClass().getName());
//				}
//			}
		} else if (map != null) {
			try {
				bean = paramType.newInstance();
			} catch (IllegalAccessException | InstantiationException e) {
				throw new BindBeanException(e);
			}

			BeanUtil.mapToBean(map, bean);
			request.setAttribute(BEAN_ROW_MAP, bean);
			request.removeAttribute(BEAN_ROW_BEAN);
		}

		return bean;
	}

	private List<?> getBeanRows(Class<?> paramType, HttpServletRequest request) {
		List<SwMap> map = (List<SwMap>)request.getAttribute(BEAN_ROWS_MAP);
		List<?> bean = (List<?>)request.getAttribute(BEAN_ROWS_BEAN);

		if (bean != null) {
			if (map != null) {
				// 逻辑有错误 map 和 bean 不会同时有值
				request.removeAttribute(BEAN_ROWS_MAP);
			}

//			if (paramType != null) {
//				if (!paramType.equals(bean.getClass())) {
//					throw new BindBeanException("type noe equals " + paramType.getName() + "," + bean.getClass().getName());
//				}
//			}
		} else if (map != null) {
  		bean = BeanUtil.toBeanList(map, paramType);
			request.setAttribute(BEAN_ROWS_BEAN, bean);
			request.removeAttribute(BEAN_ROWS_MAP);
		}

		return bean;
	}
}
