package cc.smtweb.system.bpm.core.ui.bind;

import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.mvc.controller.binder.attr.AbstractAttrEditor;
import cc.smtweb.system.bpm.util.BeanUtil;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * API函数@SwBody参数的转换处理，POST请求直接转换Json内容为Bean对象，GET请求转换Map请求参数为Bean对
 * @author xkliu
 */
public class BpmMapAttrEditor extends AbstractAttrEditor implements IBpmBeanConst {
	@Override
	public Object getValue(String paramName, Class<?> paramType, HttpServletRequest request) {
		if (ATTRIBUTE_ROW.equals(paramName)) {
			return getMapRow(request);
		} else if (ATTRIBUTE_ROWS.equals(paramName)) {
			return getMapRows(request);
		}

		return request.getAttribute(paramName);
	}

	private Object getMapRow(HttpServletRequest request) {
		SwMap map = (SwMap)request.getAttribute(BEAN_ROW_MAP);
		Object bean = request.getAttribute(BEAN_ROW_BEAN);

		if (map != null) {
			if (bean != null) {
				// 逻辑有错误 map 和 bean 不会同时有值
				request.removeAttribute(BEAN_ROW_BEAN);
			}
		} else if (bean != null) {
			map = new SwMap();
			BeanUtil.beanToMap(bean, map);
			request.setAttribute(BEAN_ROW_MAP, map);
			request.removeAttribute(BEAN_ROW_BEAN);
		}

		return map;
	}

	private Object getMapRows(HttpServletRequest request) {
		List<SwMap> map = (List<SwMap>)request.getAttribute(BEAN_ROWS_MAP);
		List<?> bean = (List<?>)request.getAttribute(BEAN_ROWS_BEAN);

		if (map != null) {
			if (bean != null) {
				// 逻辑有错误 map 和 bean 不会同时有值
				request.removeAttribute(BEAN_ROWS_BEAN);
			}
		} else if (bean != null) {
			map = BeanUtil.toMapList(bean);
			request.setAttribute(BEAN_ROWS_MAP, map);
			request.removeAttribute(BEAN_ROWS_BEAN);
		}

		return map;
	}
}
