package cc.smtweb.system.bpm.core.ui.service.list.agent;

import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.service.AbstractDatasetAgent;
import cc.smtweb.system.bpm.core.ui.service.DatasetApiInvoker;
import lombok.Setter;

import java.util.function.Function;
/**
 * list数据集统计方法代理执行，调用@BpmEvent的事件
 * @author xkliu
 */
public class DatasetCountAgent extends AbstractDatasetAgent {
  @Setter
  private DatasetApiInvoker beforeCount;
  @Setter
  private DatasetApiInvoker afterCount;
  @Setter
  private DatasetApiInvoker count;

  private final Function<BpmPageContext, SwMap> defaultCountFunc;

  public DatasetCountAgent(Function<BpmPageContext, SwMap> countFunc) {
    this.defaultCountFunc = countFunc;
  }

  public SwMap doCount(BpmPageContext pageContext) {
    // bean 处理
    if (beforeCount != null) {
      beforeCount.invoke(pageContext);
    }

    if (this.count != null) {
      Object bean = this.count.invoke(pageContext);
      saveAttrRow(pageContext, bean);
    } else {
      SwMap body = this.defaultCountFunc.apply(pageContext);
      saveAttrRowMap(pageContext, body);
    }

    if (afterCount != null) {
      afterCount.invoke(pageContext);
    }

    return loadAttrRowMap(pageContext);
  }
}
