package cc.smtweb.system.bpm.core.ui.service.tree;

import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.entity.dataset.BpmDataset;
import cc.smtweb.system.bpm.core.ui.service.DatasetWorker;

import java.util.List;
import java.util.function.Function;

public class DatasetTreeWorker extends DatasetWorker {
  protected Function<BpmPageContext, List<SwMap>> treeAllFunc;
  protected Function<BpmPageContext, List<SwMap>> treeFunc;
  protected Function<BpmPageContext, Integer> moveFunc;

  public DatasetTreeWorker(BpmPageContext pageContext) {
    super(pageContext);
  }

  public void handleTreePart(Function<BpmPageContext, List<SwMap>> treeFunc) {
    this.treeFunc = treeFunc;
  }

  public void handleMove(Function<BpmPageContext, Integer> moveFunc) {
    this.moveFunc = moveFunc;
  }

  public void handleTreeAll(Function<BpmPageContext, List<SwMap>> treeAllFunc) {
    this.treeAllFunc = treeAllFunc;
  }

  public List<SwMap> tree(BpmDataset dataset) {
    pageContext.setDataset(dataset);
    return treeFunc.apply(pageContext);
  }

  public List<SwMap> treeAll(BpmDataset dataset) {
    pageContext.setDataset(dataset);
    return treeAllFunc.apply(pageContext);
  }

  public Integer move(BpmDataset dataset) {
    pageContext.setDataset(dataset);
    return moveFunc.apply(pageContext);
  }
}
