package cc.smtweb.system.bpm.spring.dao;

import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.db.sqlbuilder.AbstractSelectSqlBuilder;
import cc.smtweb.system.bpm.core.ui.BpmPageContext;
import cc.smtweb.system.bpm.core.ui.IParamConst;
import cc.smtweb.system.bpm.core.ui.builder.TreeDataBuilder;
import cc.smtweb.system.bpm.core.ui.entity.dataset.BpmDataset;
import cc.smtweb.system.bpm.engine.entity.AspModelTreeVO;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class DatasetTreeDao extends AbstractDatasetPlugin {
  public List<SwMap> treeAll(BpmPageContext ctx) {
    TreeDataBuilder treeDataBuilder = new TreeDataBuilder(ctx.getDataset(), null, null);

    AbstractSelectSqlBuilder sqlBuilder = treeDataBuilder.tableSqlBuilder();

    List<SwMap> list = sqlBuilder.query(dbEngine, SwMap.class);

    AspModelTreeVO root = new AspModelTreeVO();
    root.setModelName("项目");

    return treeDataBuilder.buildTree(list, true);
  }

  public List<SwMap> tree(BpmPageContext ctx) {
    SwMap body = ctx.getBody();
    Long parentId = body.readLong(IParamConst.PARAM_PARENT_ID);
    TreeDataBuilder treeDataBuilder = new TreeDataBuilder(ctx.getDataset(), parentId, null);

    AbstractSelectSqlBuilder sqlBuilder = treeDataBuilder.tableSqlBuilder();

    sqlBuilder.addWhere(treeDataBuilder.getParentField().getFieldName(), parentId);

    return sqlBuilder.query(dbEngine, SwMap.class);
  }

  public int move(BpmPageContext ctx) {
    TreeDataBuilder treeDataBuilder = TreeDataBuilder.create(ctx);

    List<Object[]> params = new ArrayList<>();
    Long parentId = treeDataBuilder.getParentId();
    Long[] orders = treeDataBuilder.getOrders();

    int index = 0;
    for (Long order: orders) {
      params.add(new Object[]{parentId, ++index, order});
    }

    BpmDataset dataset = treeDataBuilder.getDataset();

    int[] ret = dbEngine.batchUpdate("update " + dataset.fullName() + " set " + treeDataBuilder.getParentField().getFieldName() + "=?, "
            + treeDataBuilder.getOrderField().getFieldName() + "=? where " + dataset.readIdFieldName() + "=?", params);

    return ret.length;
  }
}
