package cc.smtweb.system.bpm.web.design.form;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwException;
import cc.smtweb.framework.core.mvc.service.DefaultLoadHandler;

/**
 * Created by Akmm at 2022/5/9 16:17
 */
public class ModelFormLoadHandler extends DefaultLoadHandler<ModelForm> {
    public ModelFormLoadHandler() {
        super(ModelForm.ENTITY_NAME);
    }

    @Override
    protected ModelForm loadComp(long id) {
        ModelForm bean = super.loadComp(id);
        //去掉content和dataset
        bean.getData().remove("mf_content");
        bean.getData().remove("mf_dataset");
        return bean;
    }

    //页面设计-加载数据集定义
    public R loadDataset() {
        long id = params.readLong("id");
        ModelForm bean = super.loadComp(id);
        if (bean == null) throw new SwException("没有找到指定定义信息！id=" + id);
        return R.success(ModelFormHelper.buildReqDataset(bean.getDataset()));
    }

    //页面设计 - 加载页面model定义
    public R loadModel() {
        long id = params.readLong("id");
        ModelForm bean = super.loadComp(id);
        if (bean == null) throw new SwException("没有找到指定定义信息！id=" + id);
        return R.success(ModelFormHelper.buildReqModel(bean));
    }

    //页面引擎-获取页面模型
    public R loadForm() {
        long id = params.readLong("id");
        ModelForm bean = super.loadComp(id);
        if (bean == null) throw new SwException("没有找到指定定义信息！id=" + id);
        return R.success(ModelFormHelper.buildEngineModel(bean, params, us));
    }

    //获取页面使用的控件的filter信息
    public R loadWidgetFilter() {
        long id = params.readLong("id");
        ModelForm bean = super.loadComp(id);
        if (bean == null) throw new SwException("没有找到指定控件定义！id=" + id);
        return R.success(ModelFormHelper.buildWidgetFilter(bean));
    }
}
