package cc.smtweb.system.bpm.web.design.form.define;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sun.istack.internal.NotNull;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Akmm at 2022/5/25 15:53
 * 数据集集合
 */
public class PageDatasets {
    public List<PageDataset> list;

    @JsonIgnore
    private Map<String, PageDataset> mapId = null;
    @JsonIgnore
    private Map<String, PageDataset> mapName = null;

    public PageDatasets(@NotNull PageDataset[] datasets) {
        this.list = new ArrayList<>(datasets.length);
        this.mapId = new HashMap<>(datasets.length);
        this.mapName = new HashMap<>(datasets.length);
        for (PageDataset ds : datasets) {
            this.list.add(ds);
            mapId.put(ds.id, ds);
            mapName.put(ds.name, ds);
            ds.resetFields();
        }
    }

    public PageDataset findById(String id) {
        return mapId.get(id);
    }

    public PageDataset findByName(String name) {
        return mapName.get(name);
    }
}
