package cc.smtweb.system.bpm.web.design.preview;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.annotation.SwParam;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.db.DbEngine;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.util.TreeDataUtil;
import cc.smtweb.system.bpm.web.design.preview.entity.MenuVO;

import java.util.List;

@SwService
public class PreviewMenuTreeService {
  @SwParam
  private DbEngine dbEngine;

  public R treeAll(@SwParam("module") String module, UserSession us) {
    Long mcId = dbEngine.queryLong("select mc_id from sw_bpm.asp_model_catalog where mc_module=? and mc_site_id=?", module, us.getSiteId());
    if (mcId == null) {
      return R.error(module + " 模块不存在!");
    }
    /*
     *             id: "11",
     *             name: "用户管理",
     *             icon: "",
     *             path: "/bpm/uc.system.user.list",
     */
    String sql = "select model_id id, model_parent_id parent_id, model_key path, model_name name from sw_bpm.asp_model" +
            " where model_mc_id=? and model_type=? and model_site_id=? order by model_order, model_id";
    List<MenuVO> list = dbEngine.query(sql, MenuVO.class, mcId, 3, us.getSiteId());

    MenuVO root = new MenuVO();
    root.setName("项目");
    root.setPath(module);
    List<MenuVO> data = TreeDataUtil.buildTree(root, list, MenuVO.createTreeHandler());
    fixPath(data, "/bpm/" + module);

    return R.success(data);
  }

  private void fixPath(List<MenuVO> children, String path) {
    if (children != null) {
      for (MenuVO menu : children) {
        menu.setPath(path + "." + menu.getPath());
        fixPath(menu.getChildren(), menu.getPath());
      }
    }
  }
}
