package cc.smtweb.system.bpm.web.engine.dynPage;

import cc.smtweb.framework.core.common.SwException;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.framework.core.mvc.service.AbstractHandler;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.web.design.form.ModelFormHelper;
import cc.smtweb.system.bpm.web.design.form.define.PageDataset;
import cc.smtweb.system.bpm.web.design.form.define.PageDatasets;

import java.util.Map;

/**
 * Created by Akmm at 2022/4/21 17:53
 */
public abstract class AbstractDynPageHandler extends AbstractHandler {
    //页面定义id
    protected long pageId;
    protected PageDatasets datasets;

    protected DynPageProvider provider = new DynPageProvider();

    @Override
    public void init(SwMap params, UserSession us) {
        super.init(params, us);
        pageId = params.readLong("pageId");

        datasets = ModelFormHelper.parsePageDataset(pageId);
        if (datasets == null || datasets.list == null) throw new SwException("没有找到页面定义数据！");

        provider.pageId = pageId;
        provider.datasets = datasets;
    }

    protected PageDataset findDataset(String name) {
        return datasets.findByName(name);
    }

    //获取第一个，主数据集
    protected PageDataset findMasterDataset() {
        return datasets.list.get(0);
    }

    //从参数读取数据集定义
    protected PageDataset readParamDs() {
        //数据集
        String dbName = params.readString("dataset");
        //对应的数据集定义
        PageDataset pageDataSet = findDataset(dbName);
        if (pageDataSet == null) throw new SwException("没有找到指定的的数据集定义：" + dbName + "！");
        return pageDataSet;
    }
}
