package cc.smtweb.system.bpm.web.ui.dynform;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.annotation.SwParam;
import cc.smtweb.framework.core.annotation.SwService;
import cc.smtweb.framework.core.session.UserSession;
import cc.smtweb.system.bpm.core.ui.entity.BpmPage;
import cc.smtweb.system.bpm.spring.cache.BpmPageCache;
import org.apache.commons.lang3.StringUtils;

/**
 * 获取界面结构
 */
@SwService
public class DynFormPageService {
    @SwParam
    private BpmPageCache bpmPageCache;

    // @ApiOperation(value = "读取界面结构")
    public R load(UserSession us, @SwParam("pageName") String pageName) {
        if (StringUtils.isBlank(pageName)) {
            return R.error("必须传入参数: pageName");
        }

        BpmPage bpmPage = bpmPageCache.get(pageName);
        if (bpmPage == null) {
            bpmPage = bpmPageCache.getByOtherKey(pageName);
        }
        if (bpmPage == null) {
            return R.error("未找到页面: " + pageName);
        }

        return R.success(bpmPage);
    }
}
