package cc.smtweb.system.bpm.test;

import cc.smtweb.framework.core.common.R;
import cc.smtweb.framework.core.common.SwMap;
import cc.smtweb.system.bpm.spring.BpmApplication;
import cc.smtweb.system.bpm.web.engine.dynPage.DynPageService;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

/**
 * Created by Akmm at 2022/4/26 9:46
 */
@RunWith(SpringRunner.class)
@SpringBootTest(classes = BpmApplication.class)
public class ModelFormTest {
    @Test
    public void testLoad() {
        SwMap params = new SwMap();
        params.put("pageId", 1);
        params.put("dataset", "modelProject");
        SwMap filter = new SwMap();
        filter.put("prj_name", "测试");
        params.put("filter", filter);
        DynPageService service = new DynPageService();
        R r = service.load(params, null);
        System.out.println(r.readSuccess());
    }

    @Test
    public void testSave() {
        //{pageId,dataset:"", data:{form:{},list: {total:0,rows:[]}}, filter:{}}
        SwMap params = new SwMap();
        params.put("pageId", 1);
        params.put("dataset", "modelProject");
        SwMap data = new SwMap();
        SwMap form = new SwMap();
        form.put("prj_id", "12345");
        form.put("prj_name", "test12345");
        form.put("prj_desc", "this is test12345");
        data.put("form", form);
        params.put("data", data);
        SwMap filter = new SwMap();
        filter.put("prj_name", "测试");
        params.put("filter", filter);
        DynPageService service = new DynPageService();
        R r = service.saveOne(params, null);
        System.out.println(r.readSuccess());
    }

    @Test
    public void testDel() {
        //{pageId,dataset:"", data:{form:{},list: {total:0,rows:[]}}, filter:{}}
        SwMap params = new SwMap();
        params.put("pageId", 1);
        params.put("id", 12345);

        DynPageService service = new DynPageService();
        R r = service.del(params, null);
        System.out.println(r.readSuccess());
    }
}
